//
// Created by cse on 2/17/17.
//

#ifndef LIGHTNINGOBJECTS_DIRECTBUFFER_H
#define LIGHTNINGOBJECTS_DIRECTBUFFER_H

#include <QIODevice>

namespace lo {
namespace base {

/**
 * had to create this because Qt didn't have anything that would write through immediately.
 * Only used for serializing data to database columns, not tested in general use
 */
class DirectBuffer : public QIODevice
{
  uchar * const _data;
  const size_t _size;
  size_t _pos;

public:
  DirectBuffer(uchar *data, size_t size) : _data(data), _size(size), _pos(0) {}

protected:
  qint64 writeData(const char *data, qint64 len) override;
  qint64 readData(char *data, qint64 maxlen) override;
};

}
}


#endif //LIGHTNINGOBJECTS_DIRECTBUFFER_H
